<?php
/*******************************************************************************/
//                          InstantCMS v1.9                                    //
//                      http://www.instantcms.ru/                              //
//                         plugin p_contextlinks v2.0                          //
//                     written by Marat Fatikhov  aka                     //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/

class p_contextlinks extends cmsPlugin {

// ==================================================================== //

    public function __construct(){
        
        parent::__construct();

        //   

        $this->info['plugin']           = 'p_contextlinks';
        $this->info['title']            = ' ';
        $this->info['description']      = '     ';
        $this->info['author']           = 'Marat Fatikhov, modified by googlebot';
        $this->info['version']          = '2.1';

        //  -

        $this->config['|.  - .']   = " |neftekamcy.ru \n  |/ \n";
        $this->config['   .  - ']   = '';
		$this->config['    ']   = 0;

        // ,    

        $this->events[]                 = 'GET_POSTS';
        $this->events[]                 = 'GET_POST';
        $this->events[]                 = 'GET_LATEST_POSTS';
        $this->events[]                 = 'GET_BEST_POSTS';
        $this->events[]                 = 'GET_COMMENTS';
        $this->events[]                 = 'GET_FORUM_POSTS';
        $this->events[]                 = 'GET_WALL_POSTS';
        $this->events[]                 = 'GET_ARTICLE';
        $this->events[]                 = 'GET_ARTICLES';

    }

// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function install(){

        return parent::install();

    }

// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    /**
     *  
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){

        parent::execute();

        switch ($event){
            case 'GET_POST': $item = $this->eventGetPost($item); break;
            case 'GET_POSTS': $item = $this->eventGetPosts($item); break;
            case 'GET_LATEST_POSTS': $item = $this->eventGetPosts($item); break;
            case 'GET_BEST_POSTS': $item = $this->eventGetPosts($item); break;
            case 'GET_COMMENTS': $item = $this->eventGetComments($item); break;
            case 'GET_FORUM_POSTS': $item = $this->eventGetComments($item); break;
            case 'GET_WALL_POSTS': $item = $this->eventGetComments($item); break;
            case 'GET_ARTICLE': $item = $this->eventGetArticle($item); break;
            case 'GET_ARTICLES': $item = $this->eventGetArticles($item); break;
        }

        return $item;

    }

// ==================================================================== //

    private function makeLink($text){

        $string        = trim($this->config['|.  - .']);
		if (!$string) { return $text; }
        $limit          = $this->config['   .  - '];
		$isolation		= $this->config['    '];
		if ($isolation==0) {$iso = '\b';} else {$iso = '[A-Za-z--߸0-9]*';}

        $toArray = explode("\n", $string);
        for($i=0; $i<sizeof($toArray); $i++){
            list($pattern[$i],$replacement[$i]) = explode("|", trim($toArray[$i]));
        }

        
        foreach($replacement as $key=>&$value){
            $value = htmlspecialchars(strip_tags(trim($value)));
			if($value{0} != '/'){
            $value = 'http://'.str_replace('http://', '', $value);
			}
			if ($isolation == 0) {
				$value = '$1<a href="'.$value.'">$2</a>$3';
			} else {
				$value = '<a href="'.$value.'">$1$2$3</a>';
			}
        }
        foreach($pattern as $k=>&$v){
            $v = '/('.$iso.')('.trim($v).')('.$iso.')/is';
        }

        //,  
        if(!is_numeric($limit)){ $limit = -1; }
        
        //      ,   
        if(count($pattern) != count($replacement)){ return $text; }
		
		//      
		$regexp = '/(<a\s+[^>]*>[\W\w]*?<\/a>|<iframe[^>]*>[\W\w]*?<\/iframe>|<script[^>]*>[\W\w]*?<\/script>|<object[^>]*>[\W\w]*?<\/object>|<embed[^>]*>[\W\w]*?<\/embed>|<[^>]*?>)/i';
		preg_match_all($regexp, $text, $remember);
		
		//     
		$placeholder = '{placeholder}';
		$text = preg_replace($regexp, $placeholder, $text);

        //     
		$text = preg_replace($pattern, $replacement, $text, $limit);

		//  
		$p = '/('.$placeholder.')/';
		if (count($remember[0])){
			foreach($remember[0] as $r){
				$text = preg_replace($p, $r, $text, 1);
				}
			}
		return $text;

    }

    private function eventGetPost($item) {

        if (!is_array($item)){ return $item; }

        $item['content_html'] = $this->makeLink($item['content_html']);

        return $item;

    }

    private function eventGetPosts($items){

        if (!is_array($items)){ return $items; }

        foreach($items as $i=>$item){
            $items[$i]['content_html'] = $this->makeLink($item['content_html']);
        }
        
        return $items;
    }

    private function eventGetComments($items){

        if (!is_array($items)){ return $items; }

        foreach($items as $i=>$item){
            $items[$i]['content'] = $this->makeLink($item['content']);
        }

        return $items;
    }
    
    private function eventGetArticle($item){

        if (!is_array($item)){ return $item; }

           $item['content'] = $this->makeLink($item['content']);

        return $item;
    }
    
    private function eventGetArticles($items){

        if (!is_array($items)){ return $items; }

        foreach($items as $i=>$item){
            $items[$i]['description'] = $this->makeLink($item['description']);
        }

        return $items;
    }

// ==================================================================== //

}

?>
